const coral = @import("coral");

const std = @import("std");

fn Handle(comptime HandleDesc: type) type {
	return enum (u32) {
		default,
		_,

		pub const Desc = HandleDesc;

		const Self = @This();
	};
}

pub const Texture = Handle(struct {
	format: Format,
	access: Access,

	pub const Access = union (enum) {
		static: Static,
		render: Render,

		pub const Static = struct {
			width: u16,
			data: []const coral.io.Byte,
		};

		pub const Render = struct {
			width: u16,
			height: u16,
		};
	};

	pub const Format = enum {
		rgba8,
		bgra8,

		pub fn byte_size(self: Format) usize {
			return switch (self) {
				.rgba8, .bgra8 => 4,
			};
		}
	};
});
